## EMBOSS: codcmp

# Program codcmp

## Function

Codon usage table comparison

## Description

This program reads in two codon usage table files.

It counts the number of the 64 possible codons which are unused (i.e. has a usage fraction of 0) in either one or the other or both of the codon usage tables.

The usage fraction of a codon is its proportion (0 to 1) of the total of the codons in the sequences used to construct the usage table.

For each codon that is used in both tables, it takes the difference between the usage fraction. The sum of the differences and the sum of the differences squared is reported in the output file, together with the number of unused codons.

## Usage

Here is a sample session with codcmp, comparing the codon usage tables for Escherichia coli and Haemophilus influenzae.

    % codcmp
    Codon usage file [Ehum.cut]: Eeco.cut
    Codon usage file [Ehum.cut]: Ehin.cut
    Output file [outfile.codcmp]:

## Command line arguments

       Mandatory qualifiers:
      [-first]             codon      First codon usage file
      [-second]            codon      Second codon usage file
      [-outfile]           outfile    Output file name

       Optional qualifiers: (none)
       Advanced qualifiers: (none)
       General qualifiers:
      -help                bool       report command line options. More
                                      information on associated and general
                                      qualifiers can be found with -help -verbose

Mandatory qualifiers | Allowed values | Default
--- | --- | ---
[-first] (Parameter 1) | First codon usage file | Codon usage file in EMBOSS data path | Ehum.cut
[-second] (Parameter 2) | Second codon usage file | Codon usage file in EMBOSS data path | Ehum.cut
[-outfile] (Parameter 3) | Output file name | Output file | <sequence>.codcmp
Optional qualifiers | Allowed values | Default
(none)
Advanced qualifiers | Allowed values | Default
(none)

## Input file format

It reads in the Codon Usage Tables - these are available as EMBOSS data files. See below for details.

## Output file format

This is the result of the example run:

    # CODCMP codon usage table comparison
    # Eeco.cut vs Ehin.cut

    Sum Squared Difference = 2.337
    Mean Squared Difference = 0.037
    Root Mean Squared Difference = 0.191
    Sum Difference         = 9.840
    Mean Difference         = 0.154
    Codons not appearing   = 0

## Data files

The codon usage tables are read by default from "Ehum.cut" in the data/CODONS directory of the EMBOSS distribution.

If the name of a codon usage file is specified on the command line, then this file will first be searched for in the current directory and then in the 'data/CODONS' directory of the EMBOSS distribution.

To see the available EMBOSS codon usage files, run:

    % embossdata -showall

To fetch one of the codon usage tables (for example 'Emus.cut') into your current directory for you to inspect or modify, run:

    % embossdata -fetch -file Emus.cut

## Notes

None.

## References

None.

## Warnings

None.

## Diagnostic Error Messages

None.

## Exit status

This program always exits with a status of 0.

## Known bugs

None.

## See also

Program name | Description
--- | ---
cai | CAI codon adaptation index
chips | Codon usage statistics
cusp | Create a codon usage table
syco | Synonymous codon usage Gribskov statistic plot

## Author(s)

This application was written by Alan Bleasby (ableasby@hgmp.mrc.ac.uk)

Some more statistics were add by David Martin (david.martin@biotek.uio.no)

## History

Completed 9 Sept 1999
20 Oct 2000 - David Martin added a couple more statistics to the output.

## Target users

This program is intended to be used by everyone and everything, from naive users to embedded scripts.

## Comments